{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O+,R-,S+,V-,X+}
{$M 16384,0,655360}
USES CRT,Cursor,StrUtil;

CONST XBLen=10240;
      XBInc=9*1024;

VAR Filename:STRING;
    F:FILE;
    ol:LONGINT;
    Offset:LONGINT;
    FLen:LONGINT;
    XBuf:ARRAY[0..XBLen-1] OF BYTE;

PROCEDURE Frame(X1,Y1,X2,Y2:INTEGER);
VAR X,Y:INTEGER;
BEGIN
  GotoXY(X1,Y1);
  Write('');
  FOR X:=X1+2 TO X2 DO Write('');
  Write('');
  FOR Y:=Y1+1 TO Y2 DO BEGIN
    GotoXY(X1,Y);
    Write('','':X2-X1);
  END;
  GotoXY(X1,Y2);
  Write('');
  FOR X:=X1+2 TO X2 DO Write('');
  Write('');
END;

PROCEDURE Window(X1,Y1,X2,Y2:INTEGER; Title:STRING; Col:BYTE);
BEGIN
  TextAttr:=Col;
  Frame(X1,Y1,X2,Y2);
  GotoXY((X2+X1-Length(Title)) DIV 2-1,Y1);
  Write(' ',Title,' ');
END;

PROCEDURE Messagebox(Tit,Txt:STRING);
VAR X:INTEGER;
BEGIN
  X:=38-Length(Txt) DIV 2;
  Window(X,11,X+Length(Txt)+5,13,Tit,$4F);
  GotoXY(X+3,12);
  Write(Txt);
  REPEAT UNTIL Readkey<>#0;
END;

PROCEDURE WriteC(X,Y:INTEGER; S:STRING; a,b:BYTE);
VAR i:INTEGER;
BEGIN
  IF X>0 THEN GotoXY(X,Y);
  TextAttr:=a;
  FOR i:=1 TO Length(S) DO CASE S[i] OF
    '{':TextAttr:=b;
    '}':TextAttr:=a;
  ELSE
    IF S[i]='\' THEN Inc(i);
    Write(S[i]);
  END;
END;

PROCEDURE ShowMenu;
BEGIN
  Window(1,20,80,25,'Menu',16+15);
  WriteC(3,21,'{E}xtract file portion',$17,$1F);
  WriteC(3,22,'{S}can for known file types',$17,$1F);
  WriteC(3,23,'{O}pen file',$17,$1F);
  WriteC(3,24,'{Q}uit',$17,$1F);
  WriteC(43,21,'Use {} to scroll',$17,$1F);
  WriteC(43,22,'{G}o to offset',$17,$1F);
  IF Filename<>'' THEN WriteC(33,24,'Current file: {'+itoa(FLen)+'} ({$'+hex(Flen,4)+'}) bytes',$17,$1F);
END;

PROCEDURE Framework;
VAR S:STRING;
BEGIN
  S:='Ripper';
  IF Filename<>'' THEN S:=S+': '+Filename;
  Window(1,1,80,19,S,$1F);
  ShowMenu;
END;

PROCEDURE ShowContents;
VAR i,j:INTEGER;
    O:LONGINT;
    Buf:ARRAY[0..15] OF BYTE;
    R:WORD;
    S:STRING[10];
BEGIN
  O:=Offset;
  TextAttr:=$17;
  FOR i:=2 TO 18 DO BEGIN
    GotoXY(2,i);
    IF O<=FLen THEN BEGIN
      S:=Hex(O,6);
      IF Length(S)=6 THEN S:=' '+S;
      Write(S,': ');
      Seek(F,O);
      Blockread(F,Buf,16,R);
      IF R>0 THEN
      FOR j:=0 TO R-1 DO BEGIN
        Write(Hex(Buf[j],2));
        IF j AND 3=3 THEN Write('  ') ELSE Write(' ');
      END;
      FOR j:=R TO 15 DO BEGIN
        Write('   ');
        IF j AND 3=3 THEN Write(' ');
      END;
      IF R>0 THEN
      FOR j:=0 TO R-1 DO BEGIN
        CASE Buf[j] OF
          7,8,9,10,13:Write('.');
        ELSE Write(Chr(Buf[j]));
        END;
      END;
      FOR j:=R TO 15 DO Write(' ');
      IF Length(S)<>8 THEN Write(' ');
    END ELSE
     Write('':78);
    Inc(O,16);
  END;
END;

FUNCTION Input(X,Y:INTEGER; Prompt:STRING; VAR S:STRING; Max:INTEGER; Chrs:STRING; Up:BOOLEAN):BOOLEAN;
VAR C:CHAR;
    i:INTEGER;
BEGIN
  REPEAT
    GotoXY(X,Y);
    TextAttr:=$31;
    Write(Prompt);
    TextAttr:=15;
    Write(S);
    TextAttr:=7;
    FOR i:=Length(S)+1 TO Max DO Write('');
    GotoXY(X+Length(Prompt)+Length(S),Y);
    CursorOn;
    C:=Readkey;
    CursorOff;
    CASE C OF
      #8:IF S<>'' THEN Dec(S[0]);
      #25:S:='';
      #27:BEGIN
        Input:=FALSE;
        Exit;
      END;
      #13:BEGIN
        Input:=TRUE;
        Exit;
      END;
      #32..#255:BEGIN
        IF Up THEN C:=Upcase(C);
        IF ((Chrs='') OR (Pos(C,Chrs)>0)) AND (Length(S)<Max) THEN S:=S+C;
      END;
    END;
  UNTIL FALSE;
END;

PROCEDURE ClrEOW;
VAR i:INTEGER;
BEGIN
  FOR i:=WhereX TO 79 DO Write(' ');
END;

FUNCTION DoExtract(Start,Len:LONGINT; Name:STRING; Crea:BOOLEAN):BOOLEAN;
VAR F1:FILE;
    R,W,X:WORD;
BEGIN
  DoExtract:=FALSE;
  Assign(F1,Name);
  IF Crea THEN BEGIN
    Rewrite(F1,1);
  END ELSE BEGIN
    Filemode:=1;
    Reset(F1,1);
    IF IOResult<>0 THEN Rewrite(F1,1) ELSE Seek(F1,Filesize(F1));
  END;
  IF IOResult<>0 THEN BEGIN
    MessageBox('Error','Can''t create file.');
    Framework;
    ol:=-1;
    Exit;
  END;
  SeeK(F,Start);
  WHILE Len>0 DO BEGIN
    IF Len>XBLen THEN X:=XBLen ELSE X:=Len;
    Blockread(F,XBuf,X,R);
    Dec(Len,R);
    IF X<>R THEN BEGIN
      Close(F1);
      Messagebox('Error','Source file is '+itoa(Len)+' bytes too short.');
      Framework;
      ol:=-1;
      Exit;
    END;
    Blockwrite(F1,XBuf,R,W);
    IF R<>W THEN BEGIN
      Close(F1);
      MessageBox('Error','Disk full, '+itoa(Len+R-W)+' bytes not copied.');
      Framework;
      ol:=-1;
      Exit;
    END;
  END;
  Close(F1);
  DoExtract:=TRUE;
END;

PROCEDURE ExtractPortion;
VAR S:STRING;
    Start,Len,L:LONGINT;
    i:INTEGER;
    C:CHAR;
    Quit,Crea:BOOLEAN;
BEGIN
  IF Filename='' THEN Exit;
  Window(1,20,80,25,'Extract File Portion',$3F);
  S:='';
  IF Input(3,21,'Starting offset (hex): ',S,8,'0123456789ABCDEF',TRUE) AND (S<>'') THEN
  BEGIN
    Val('$'+S,Start,i);
    Quit:=(Start>=FLen) OR (Start<0);
    Len:=0;
    WHILE NOT Quit DO BEGIN
      WriteC(3,22,'- {E}nding offset',$30,$3F); clrEOW;
      WriteC(3,23,'- {L}ength',$30,$3F); CLREOW;
      WriteC(3,24,'- {T}o end of file',$30,$3F);
      C:=Upcase(Readkey);
      CASE c OF
        #0:Readkey;
        'T':BEGIN
          Quit:=TRUE;
          Len:=FLen-Start;
        END;
        'E':BEGIN
          S:='';
          Quit:=Input(5,22,'Ending offset (hex): ',S,8,'0123456789ABCDEF',TRUE) AND (S<>'');
          IF Quit THEN BEGIN
            Val('$'+S,Len,i);
            IF Len<Start THEN BEGIN
              L:=Len;
              Len:=Start;
              Start:=Len;
            END;
            Dec(Len,Start-1);
          END;
        END;
        'L':BEGIN
          S:='';
          Quit:=Input(5,23,'Length (decimal): ',S,8,'0123456789',TRUE) AND (S<>'');
          IF Quit THEN BEGIN
            Val(S,Len,i);
          END;
        END;
        #27:Quit:=TRUE;
      END;
    END;
    IF Len<>0 THEN BEGIN
      Window(1,20,80,25,'Extract File Portion',$3F);
      WriteC(3,21,'Extract {'+itoa(Len)+'} bytes from offset {$'+Hex(Start,4)+'}:',$30,$3F);
      Quit:=FALSE;
      REPEAT
        WriteC(3,22,'- {C}reate new file',$30,$3F); ClrEOW;
        WriteC(3,23,'- {A}ppend to file',$30,$3F); ClrEOW;
        C:=Upcase(Readkey);
        S:='';
        CASE C OF
          #0:Readkey;
          'C':IF Input(5,22,'Create new file: ',S,57,'',FALSE) AND (S<>'') THEN BEGIN
            Quit:=TRUE;
            Crea:=TRUE;
          END;
          'A':IF Input(5,23,'Append to file: ',S,58,'',FALSE) AND (S<>'') THEN BEGIN
            Quit:=TRUE;
            Crea:=FALSE;
          END;
          #27:Quit:=TRUE;
        END;
      UNTIL Quit;
      IF S<>'' THEN DoExtract(Start,Len,S,Crea);
    END;
  END;
  ShowMenu;
END;

PROCEDURE OpenFile;
VAR S:STRING;
BEGIN
  Window(1,20,80,25,'Open File',$3F);
  S:='';
  IF Input(3,21,'New File Name: ',S,61,'',FALSE) AND (S<>'') THEN BEGIN
    IF Filename<>'' THEN Close(F);
    Filename:=S;
    Offset:=0;
    ol:=-1;
    FLen:=-1;
    Assign(F,Filename);
    Filemode:=0;
    Reset(F,1);
    IF IOResult<>0 THEN BEGIN
      Messagebox('Error','File not found.');
      Filename:='';
    END ELSE FLen:=FileSize(F);
    Framework;
  END ELSE ShowMenu;
END;

PROCEDURE GotoPos;
VAR S:STRING;
    i:INTEGER;
    L:LONGINT;
BEGIN
  IF Filename='' THEN EXit;
  Window(1,20,80,25,'Go to offset',$3F);
  S:='';
  IF Input(3,21,'Enter new Offset (hex): ',S,8,'0123456789ABCDEF',TRUE) AND (S<>'') THEN BEGIN
    Val('$'+S,L,i);
    IF L<0 THEN L:=0;
    IF L>Flen-224 THEN L:=FLen-224;
    Offset:=L AND NOT 15;
  END;
  ShowMenu;
END;

CONST Accept:WORD=$FFFF;
      Action:BYTE=0;

PROCEDURE ShowAccept;
VAR i:INTEGER;
BEGIN
  TextAttr:=$3F;
  FOR i:=0 TO 3 DO BEGIN
    GotoXY(3,21+i);
    IF Odd(Accept SHR i) THEN Write('') ELSE Write('');
  END;
  FOR i:=0 TO 1 DO BEGIN
    GotoXY(43,21+i);
    IF Odd(Accept SHR (i+4)) THEN Write('') ELSE Write('');
  END;
  GotoXY(43,24);
  CASE Action OF
    0:WriteC(0,0,'{A} Action: Confirm each file',$30,$3F);
    1:WriteC(0,0,'{A} Action: Extract all      ',$30,$3F);
    2:WriteC(0,0,'{A} Action: Count only       ',$30,$3F);
  END;
END;

VAR BufOfs:LONGINT;
    BufLen:WORD;

PROCEDURE Progress;
VAR ii,i:INTEGER;
BEGIN
  ii:=(BufOfs*50) DIV FLen;
  WriteC(3,21,'Progress: {',$30,$3B);
  FOR i:=1 TO 50 DO IF i<=ii THEN Write('') ELSE BEGIN
    TextAttr:=$0B;
    Write('');
  END;
END;

{ S mu mindestens 2 Zeichen haben }
FUNCTION LocateStr(S:STRING):WORD; ASSEMBLER;
ASM
                mov     si,offset XBuf
                mov     cx,XBInc
                mov     ax,BufLen
                cmp     cx,ax
                jb      @@ok
                xchg    ax,cx
@@ok:           les     di,S
                mov     ah,es:[di+1]
                cld
@@Loop:         lodsb
                cmp     al,ah
                je      @@Checkit
@@No1:          loop    @@Loop
                mov     ax,-1
                jmp     @@Ende

@@No:           pop     cx
                jmp     @@No1

@@Checkit:      push    cx
                mov     cl,es:[di]
                mov     ch,0
                mov     bx,2
                dec     cx
@@CmpLoop:      mov     al,es:[di+bx]
                cmp     al,[si+bx-2]
                jne     @@No
                inc     bx
                loop    @@CmpLoop

                mov     ax,si
                sub     ax,offset XBuf
                dec     ax
@@Ende:
END;

FUNCTION ByteAt(L:LONGINT):BYTE;
VAR Y:BYTE;
BEGIN
  IF (L<0) OR (L>=FLen) THEN ByteAt:=0 ELSE
  IF (L>=BufOfs) AND (L<BufOfs+BufLen) THEN ByteAt:=XBuf[L-BufOfs] ELSE
  BEGIN
    Seek(F,L);
    Blockread(F,Y,1);
    ByteAt:=Y;
  END;
END;

FUNCTION WordAt(L:LONGINT):WORD;
BEGIN
  WordAt:=ByteAt(L) + 256*WORD(ByteAt(L+1));
END;

FUNCTION TriAt(L:LONGINT):LONGINT;
BEGIN
  TriAt:=WordAt(L) + 65536*LONGINT(ByteAt(L+2));
END;

FUNCTION LongAt(L:LONGINT):LONGINT;
BEGIN
  LongAt:=WordAt(L) + 65536*LONGINT(WordAt(L+2));
END;

FUNCTION BELongAt(L:LONGINT):LONGINT;
BEGIN
  BELongAt:=Swap(WordAt(L+2)) + 65536*LONGINT(Swap(WordAt(L)));
END;

VAR XName:STRING;
    XPos:LONGINT;
    XLen:LONGINT;
    XInf:STRING[20];
    XNext:LONGINT;

FUNCTION FindVOC:BOOLEAN;
VAR W:WORD;
    L:LONGINT;
BEGIN
  FindVOC:=FALSE;
  IF Accept AND 1=0 THEN Exit;
  W:=LocateStr('Creative Voice File');
  IF W=$FFFF THEN Exit;
  XPos:=W+BufOfs;
  IF XPos<XNext THEN XNext:=XPos+1;
  XLen:=26;
  WHILE ByteAt(XPos+XLen)<>0 DO BEGIN
    L:=TriAt(XPos+XLen+1);
    Inc(XLen,L+4);
  END;
  Inc(XLen);
  XName:='.VOC';
  XInf:='VOC';
  FindVOC:=XPos+XLen<=FLen;
END;

FUNCTION FindWAV:BOOLEAN;
VAR W:WORD;
BEGIN
  FindWAV:=FALSE;
  IF Accept AND 2=0 THEN Exit;
  W:=Locatestr('RIFF');
  IF W=$FFFF THEN Exit;
  XPos:=BufOfs+W;
  IF XPos<XNext THEN XNext:=XPos+1;
  XLen:=LongAt(XPos+4)+8;
  IF Xpos+XLen>FLen THEN Exit;
  IF LongAt(XPos+8)=$45564157 THEN BEGIN
    XName:='.WAV';
    XInf:='Wave';
    FindWAV:=TRUE;
  END ELSE
  IF LongAt(XPos+8)=$44494d52 THEN BEGIN
    XName:='.RMI';
    XInf:='Midi';
    FindWAV:=TRUE;
  END;
END;

FUNCTION FindBMP:BOOLEAN;
VAR W:WORD;
BEGIN
  FindBMP:=FALSE;
  IF Accept AND 4=0 THEN Exit;
  W:=LocateStr('BM');
  IF W=$FFFF THEN Exit;
  XPos:=BufOfs+W;
  IF XPos<XNext THEN XNext:=XPos+1;
  XLen:=LongAt(XPos+2);
  IF XLen<50 THEN Exit;
  XName:='.BMP';
  XInf:='Bitmap';
  FindBMP:=XPos+XLen<=FLen;
END;

FUNCTION FindMID:BOOLEAN;
VAR W:WORD;
    L,P:LONGINT;
BEGIN
  FindMID:=FALSE;
  IF Accept AND 32=0 THEN Exit;
  W:=LocateStr('MThd');
  IF W=$FFFF THEN Exit;
  XPos:=BufOfs+W;
  IF XPos<XNext THEN XNext:=XPos+1;
  P:=XPos;
  REPEAT
    L := BELongAt(P+4);
    P := P + L + 8;
    L := LongAt(P);
  UNTIL (L<>$6468544D) AND (L<>$6B72544D);
  XLen:=P-XPos;
  XName:='.MID';
  XInf:='MIDI';
  FindMID:=XPos+XLen<=FLen;
END;

FUNCTION FindICE:BOOLEAN;
VAR W:WORD;
BEGIN
  FindICE:=FALSE;
  IF Accept AND 16=0 THEN Exit;
  W:=LocateStr('ICE!');
  IF W=$FFFF THEN Exit;
  XPos:=BufOfs+W;
  IF XPos<XNext THEN XNext:=XPos+1;
  XLen:=LongAt(XPos+4);
  ASM
        mov     dx,XLen.2.word
        mov     ax,XLen.0.word
        xchg    dl,dh
        xchg    al,ah
        mov     XLen.0.word,dx
        mov     XLen.2.word,ax
  END;
  IF XLen<0 THEN Exit;
  XName:='.ICE';
  XInf:='ICEd file';
  FindICE:=XPos+XLen<=FLen;
END;

FUNCTION FindZIP:BOOLEAN;
VAR W:WORD;
    ThisPos : LONGINT;
    Id      : LONGINT;
    Len     : LONGINT;
BEGIN
  FindZIP:=FALSE;
  IF Accept AND 8=0 THEN Exit;
  W:=LocateStr('PK'#3#4);
  IF W=$FFFF THEN Exit;
  XPos:=BufOfs+W;
  IF XPos<XNext THEN XNext:=XPos+1;
  ThisPos := XPos;
  REPEAT
    Id := LongAt(ThisPos);
    IF Id = $04034B50 THEN BEGIN
     { local header }
      Len := LongAt(ThisPos + 18) + WordAt(ThisPos + 26) + WordAt(ThisPos + 28)
             + 30;
    END ELSE IF Id = $02014B50 THEN BEGIN
      Len := WordAt(ThisPos + $1C) + WordAt(ThisPos + $1E) + WordAt(ThisPos + $20)
             + $2E;
    END ELSE IF Id = $06054B50 THEN BEGIN
      Len := WordAt(ThisPos + $14) + $18;
    END ELSE Len := -1;
    IF Len > 0 THEN Inc(ThisPos, Len);
  UNTIL (Len < 0) OR (ThisPos > FLen);

  XName:='.ZIP';
  XInf:='ZIP';
  XLen := ThisPos - XPos;
  FindZIP:=ThisPos<=FLen;
END;

PROCEDURE AutoExtract;
VAR Count:LONGINT;
BEGIN
  Count:=0;
  IF Accept AND $0F=0 THEN EXit;
  Window(1,20,80,25,'Scanning...',$3F);
  BufOfs:=0;
  REPEAT
    Seek(F,BufOfs);
    Blockread(F,XBuf,XBLen,BufLen);
    IF BufLen=0 THEN BEGIN
      IF Action<>0 THEN BEGIN
        Window(1,20,80,25,'Scan complete',$3F);
        WriteC(3,21,'I extracted {'+itoa(Count)+'} files.',$30,$3F);
        REPEAT UNTIL REadkey<>#0;
      END;
      Exit;
    END;
    Progress;
    XNext:=BufOfs+XBInc;
    IF (FindVOC OR FindWAV OR FindBMP OR FindZIP OR FindICE OR FindMID) AND (XLen>0) THEN BEGIN
      Inc(Count);
      WriteC(3,22,'- Found a {'+XName+'} file at {$'+hex(XPos,6)+'}, size {'+itoa(xlen)+'} bytes, #'+itoa(Count),$30,$3F);
      CLREOW;
      IF Action<>2 THEN BEGIN
        XName:=itoa(Count)+XName;
        WHILE Length(XName)<8 DO XName:='0'+XName;
        IF Action=0 THEN BEGIN
          Offset:=XPos;
          ShowContents;
          Offset:=Offset AND NOT 15;
          WriteC(3,23,'Enter file name, leave blank to ignore file, {ESC} to cancel scan:',$30,$3F);
          IF NOT Input(3,24,'',XName,76,'',FALSE) THEN Exit;
        END;
        IF XName='' THEN BufOfs:=XPos+1 ELSE BEGIN
          BufOfs:=XPos+XLen;
          IF NOT DoExtract(XPos,XLen,XName,TRUE) THEN
           Window(1,20,80,25,'Scanning...',$3F);
        END;
      END ELSE BufOfs:=XPos+1;
    END ELSE
     BufOfs:=XNext;
  UNTIL FALSE;
END;

PROCEDURE ScanFile;
VAR C:CHAR;
BEGIN
  IF Filename='' THEN Exit;
  Window(1,20,80,25,'Scan for known file types',$3F);
  WriteC(3,21,'  Accept {V}OC files',$30,$3F);
  WriteC(3,22,'  Accept {R}IFF files (WAV/RMI)',$30,$3F);
  WriteC(3,23,'  Accept {B}MP files',$30,$3F);
  WriteC(3,24,'  Accept {Z}IP files',$30,$3F);
  WriteC(43,21,'  Accept {I}CEd files',$30,$3F);
  WriteC(43,22,'  Accept {M}ID files',$30,$3F);
  WriteC(43,23,'{ENTER} Start!',$30,$3F);
  REPEAT
    ShowAccept;
    C:=Upcase(Readkey);
    CASE C OF
      #0:Readkey;
      'V':Accept:=Accept XOR 1;
      'R':Accept:=Accept XOR 2;
      'B':Accept:=Accept XOR 4;
      'Z':Accept:=Accept XOR 8;
      'I':Accept:=Accept XOR 16;
      'M':Accept:=Accept XOR 32;
      'A':IF Action<2 THEN Inc(Action) ELSE Action:=0;
      #27:BEGIN
        ShowMenu;
        Exit;
      END;
      #13:BEGIN
        AutoExtract;
        ShowMenU;
        Exit;
      END;
    END;
  UNTIL FALSE;
END;

VAR Quit:BOOLEAN;
    Ch:CHAR;
BEGIN
  TextMode(CO80);
  InitCursor;
  WindMax:=$7F7F;
  CursorOff;
  Filename:='';
  Framework;
  Offset:=0;
  FLen:=-1;
  Filename:=ParamStr(1);
  IF Filename<>'' THEN BEGIN
    Assign(F,Filename);
    Filemode:=0;
    Reset(F,1);
    IF IOResult<>0 THEN BEGIN
      Messagebox('Error','File not found.');
      Filename:='';
    END ELSE FLen:=FileSize(F);
  END;
  Framework;
  ol:=-1;
  REPEAT
    IF ol<>Offset THEN ShowContents;
    ol:=Offset;
    Ch:=Upcase(Readkey);
    Quit:=FALSE;
    CASE Ch OF
      #0:CASE Readkey OF
        #72:IF Offset>16 THEN Dec(Offset,16) ELSE Offset:=0;
        #80:IF Offset+160<FLen THEN Inc(Offset,16);
        #73:IF Offset>224 THEN Dec(Offset,224) ELSE Offset:=0;
        #81:IF Offset+224<FLen THEN Inc(Offset,224);
        #71:Offset:=0;
        #79:IF Flen>224 THEN Offset:=(Flen-224) AND (NOT 15);
      END;
      'Q',#27:Quit:=TRUE;
      'E':ExtractPortion;
      'O':OpenFile;
      'G':GotoPos;
      'S':ScanFile;
    END;
  UNTIL Quit;
  IF Filename<>'' THEN Close(F);
  TextATtr:=7;
  ClrScr;
  CursorOn;
  Writeln('STREU RIPPER is (c) 1997 by Streu Software');
  Writeln;
END.
